;
; Link routines taken from Telnet 83,
; Sent to me by Scott Dial <homosapian@geocities.com>.
; To use them call "ReceiveByte" or "SendByte". You can test the port
; (and receive byte if necessary) with "TryReceiveByte".
; There is a timer included but it is unused.
;


#define	LINKMASK	12
;stime	.db	255
;stimeout:
;	ld	a, (stime)
;	dec	a
;	ld	(stime), a
;	ret

TryReceiveByte:
	in	a,(BPORT)
	and	LINKMASK
	cp	LINKMASK
	scf
	ret	z
ReceiveByteCont:
	call	LinkPrep
	jr	ReceiveCont
ReceiveByte:
	call	LinkPrep
ReceiveBits:
	ld	de,-1
WaitRecBit:
	call	CheckLink
	jr	z,LinkFailed
	cp	LINKMASK
	jr	z,WaitRecBit
ReceiveCont:
	sub	LINKMASK/3*2
	ld	a,LINKMASK/3*2
	ld	d,D0LD1H
	jr	c,ReceiveLow
	rra
	ld	d,D0HD1L
ReceiveLow:
	rr	c
	ld	(AckBit),a
	ld	a,d
	out	(BPORT),a
	ld	de,-1
WaitAckRec:
	call	CheckLink
	cp	0
AckBit =$-1
	jr	nz,WaitAckRec
	ld	a,D0HD1H
	out	(BPORT),a
	ld	d,4
WaitReadyRec:
	dec	d
	jr	z,ReadyRec
	in	a,(BPORT)
	cp	LINKMASK
	jr	nz,WaitReadyRec
ReadyRec:
	djnz	ReceiveBits
	jr	LinkSuccess

LinkPrep:
	ex	(sp),hl
	push	bc
	push	de
	set	indicOnly,(iy+indicflags)
	ld	b,8
	jp	(hl)

SendByte:
	call	LinkPrep
	ld	c,a
	;ld	a, 255
	;ld	(stime), a
SendBits:
	rr	c
	ld	a,D0LD1H
	jr	nc,SendLow
	ld	a,D0HD1L
SendLow:
	out	(BPORT),a
	ld	de,-1
WaitAckSend:
	call	CheckLink
	jr	nz,WaitAckSend
SendAcked:
	ld	a,D0HD1H
	out	(BPORT),a
	ld	de,-1
WaitReadySend:
	call	CheckLink
	cp	LINKMASK
	jr	nz,WaitReadySend
	djnz	SendBits
LinkSuccess:
	or	0
.org $-1
LinkFailed:
	scf
	res	indicOnly,(iy+indicflags)
	ld	a,0D0h
	out	(BPORT),a
	ld	a,c
	pop	de
	pop	bc
	pop	hl
	ret

CheckLink:
	pop	hl
	dec	de
	ld	a,d
	or	e
	jr	z,LinkFailed
	ld	a,0BFh
	;call	stimeout
	;cp	0
	;call	_readkeypad
	;bit	6,a
	;jr	z,LinkFailed
	in	a,(BPORT)
	and	LINKMASK
	jp	(hl)
